"{ Package: 'stx:goodies/xtreams/substreams' }"

"{ NameSpace: Xtreams }"

ReadStream subclass:#StitchReadStream
	instanceVariableNames:'active contentsSpecies'
	classVariableNames:''
	poolDictionaries:''
	category:'Xtreams-Substreams'
!

StitchReadStream comment:'StitchReadStream combines a stream of source which returns streams in to a single continuous stream.

Instance Variables
	active  <ReadStream>    the substream that is currently active
	contentsSpecies <Class> the contents species of the substreams

'
!


!StitchReadStream class methodsFor:'instance creation'!

on: aSource contentsSpecies: aClass
	^self new on: aSource contentsSpecies: aClass
!

on: aSource first: firstActiveStream
	^self new on: aSource first: firstActiveStream
! !

!StitchReadStream methodsFor:'accessing'!

read: anInteger into: aSequenceableCollection at: startIndex
	| remaining amount index |
	index := startIndex.
	remaining := anInteger.
	amount := 0.
	[
		active == nil ifTrue: [
			[active := source get]
				on: Incomplete
				do: [:ex | (Incomplete on: aSequenceableCollection count: anInteger - remaining at: startIndex) raise]].
		amount := [active read: remaining into: aSequenceableCollection at: index] on: Incomplete do: [:ex | ex count].
		remaining := remaining - amount.
		index := index + amount.
		remaining > 0] whileTrue:
			[active close.
			active := nil].
	^anInteger
! !

!StitchReadStream methodsFor:'initialize-release'!

close
	active == nil ifFalse: [active close].
	super close
!

contentsSpecies
	^contentsSpecies
!

on: aSource contentsSpecies: aClass
	super on: aSource.
	contentsSpecies := aClass
!

on: aSource first: firstActiveStream
	super on: aSource.
	active := firstActiveStream.
	contentsSpecies := active contentsSpecies
! !

!StitchReadStream class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

