"{ Package: 'stx:goodies/xtreams/support' }"

LibraryDefinition subclass:#stx_goodies_xtreams_support
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_xtreams_support class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
	#'stx:libbasic'    "SequenceableCollection - superclass of Xtreams::InterpretedBytes "
	#'stx:libbasic2'    "SignedIntegerArray - referenced by Xtreams::InterpretedBytes class>>signedLong "
    )
! !

!stx_goodies_xtreams_support class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
	"<className> or (<className> attributes...) in load order"
	#'stx_goodies_xtreams_support'
	XtreamsPool
	#'Xtreams::InterpretedBytes'
	#'Xtreams::RecyclingCenter'
	#'Xtreams::Encoder'
	#'Xtreams::STXEncoder'
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
	Behavior absoluteName
	Block cull:
	Block cull:cull:
	Object isFixedArgument
	OrderedCollection copyGrownToAtLeast:
	SequenceableCollection copyGrownToAtLeast:
	SequenceableCollection recycle
	Symbol cull:
	#'SequenceableCollection class' newRecycled:
    )
! !

!stx_goodies_xtreams_support class methodsFor:'documentation'!

version_HG
    ^ '$Changeset: <not expanded> $'
! !

